Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  abstract class TailCalls extends SubComponent with Transform

  Perform tail recursive call elimination.

  Perform tail recursive call elimination.

  Definition Classes
    transform
  Version

    1.0

- Phase
- StdPhase
- TailCallElimination
- TailPosLabelsTraverser

c

scala.tools.nsc.transform.TailCalls

# TailCallElimination 

###

#### class TailCallElimination extends Global.Transformer

A Tail Call Transformer

Source
  TailCalls.scala
Version

  1.1 What it does: Finds method calls in tail-position and replaces them with jumps. A call is in a tail-position if it is the last instruction to be executed in the body of a method. This is done by recursing over the trees that may contain calls in tail-position (trees that can't contain such calls are not transformed). However, they are not that many. Self-recursive calls in tail-position are replaced by jumps to a label at the beginning of the method. As the JVM provides no way to jump from a method to another one, non-recursive calls in tail-position are not optimized. A method call is self-recursive if it calls the current method and the method is final (otherwise, it could be a call to an overridden method in a subclass). Furthermore, If the method has type parameters, the call must contain these parameters as type arguments. Recursive calls on a different instance are optimized. Since 'this' is not a local variable, a dummy local val is added and used as a label parameter. The backend knows to load the corresponding argument in the 'this' (local at index 0). This dummy local is never used and should be cleaned up by dead code elimination (when enabled). This phase has been moved before pattern matching to catch more of the common cases of tail recursive functions. This means that more cases should be taken into account (like nested function, and pattern cases). If a method contains self-recursive calls, a label is added to at the beginning of its body and the calls are replaced by jumps to that label. Assumes: `Uncurry` has been run already, and no multiple parameter lists exist.

Linear Supertypes
Global.Transformer, Global.Transformer, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. TailCallElimination
2. Transformer
3. Transformer
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new TailCallElimination(unit: Global.CompilationUnit)

### Type Members

1.  class ClonedTailContext extends TailContext
2.  class DefDefTailContext extends TailContext
3.  sealed trait TailContext extends AnyRef

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from TailCallElimination to any2stringadd[TailCallElimination] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (TailCallElimination, B)
   Implicit
     This member is added by an implicit conversion from TailCallElimination to ArrowAssoc[TailCallElimination] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def atOwner[A](owner: Global.Symbol)(trans: ⇒ A): A
   Definition Classes
     Transformer
8.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
9.  def currentClass: Global.Symbol
   Attributes
     protected
   Definition Classes
     Transformer
10.  def currentMethod: Global.Symbol
    Attributes
      protected
    Definition Classes
      Transformer
11.  var currentOwner: Global.Symbol
    Attributes
      protected[scala]
    Definition Classes
      Transformer
12.  def ensuring(cond: (TailCallElimination) ⇒ Boolean, msg: ⇒ Any): TailCallElimination
    Implicit
      This member is added by an implicit conversion from TailCallElimination to Ensuring[TailCallElimination] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: (TailCallElimination) ⇒ Boolean): TailCallElimination
    Implicit
      This member is added by an implicit conversion from TailCallElimination to Ensuring[TailCallElimination] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean, msg: ⇒ Any): TailCallElimination
    Implicit
      This member is added by an implicit conversion from TailCallElimination to Ensuring[TailCallElimination] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean): TailCallElimination
    Implicit
      This member is added by an implicit conversion from TailCallElimination to Ensuring[TailCallElimination] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
17.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
18.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
19.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from TailCallElimination to StringFormat[TailCallElimination] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
20.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
21.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
22.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
23.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
24.  def noTailTransform(tree: Global.Tree): Global.Tree
25.  def noTailTransforms(trees: List[Global.Tree]): collection.immutable.List[Global.Tree]
26.  final def notify(): Unit
    Definition Classes
      AnyRef
27.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
28.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
29.  def toString(): String
    Definition Classes
      AnyRef → Any
30.  def transform(tree: Global.Tree): Global.Tree
    Definition Classes
      TailCallElimination → Transformer
31.  def transform(tree: Global.Tree, nctx: TailContext): Global.Tree

    Rewrite this tree to contain no tail recursive calls

32.  def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]
    Definition Classes
      Transformer
33.  def transformIdents(trees: List[Global.Ident]): List[Global.Ident]
    Definition Classes
      Transformer
34.  def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]
    Definition Classes
      Transformer
35.  def transformModifiers(mods: Global.Modifiers): Global.Modifiers
    Definition Classes
      Transformer
36.  def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]
    Definition Classes
      Transformer
37.  def transformTemplate(tree: Global.Template): Global.Template
    Definition Classes
      Transformer
38.  def transformTrees(trees: List[Global.Tree]): List[Global.Tree]
    Definition Classes
      Transformer
39.  def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]
    Definition Classes
      Transformer
40.  def transformUnit(unit: Global.CompilationUnit): Unit
    Definition Classes
      TailCallElimination → Transformer
41.  def transformValDef(tree: Global.ValDef): Global.ValDef
    Definition Classes
      Transformer
42.  def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]
    Definition Classes
      Transformer
43.  def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]
    Definition Classes
      Transformer
44.  val treeCopy: Global.TreeCopier
    Definition Classes
      Transformer
45.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
46.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
47.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
48.  def yesTailTransform(tree: Global.Tree): Global.Tree
49.  def →[B](y: B): (TailCallElimination, B)
    Implicit
      This member is added by an implicit conversion from TailCallElimination to ArrowAssoc[TailCallElimination] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
50.  object EmptyTailContext extends TailContext

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TailCallElimination to any2stringadd[TailCallElimination]

### Inherited by implicit conversion StringFormat from TailCallElimination to StringFormat[TailCallElimination]

### Inherited by implicit conversion Ensuring from TailCallElimination to Ensuring[TailCallElimination]

### Inherited by implicit conversion ArrowAssoc from TailCallElimination to ArrowAssoc[TailCallElimination]

### Ungrouped